'AM-Modulator ATtin85 und SI5351
'531 kHz ... 1647 kHz, Raster 9 kHz
'Fuses E2, DE, FF, 1,8 V Brownout, 8 MHz
'AK Modul-Bus Computer GmbH, B. Kainka 31.3.2021


'R.Leifert: Neu eingebaut:
'-Frequenzgrenzen korrigiert
'-Schreiben der genderten MW-Frequenz ins EEPROM
'-Toggeln des MW-Rasters bei gedrckter Taste bei Einschalten

'- Erweiterung Encoder 12.11.22:


$regfile = "attiny85.dat"
$crystal = 8000000

$hwstack = 32
$swstack = 32
$framesize = 64


Dim Badr As Byte
Dim Bdat As Byte
Dim N As Byte
Dim Clk As Byte
Dim F As Single          'Frequenz fr Si
Dim F0 As Single          'abgespeicherte Frequenzen fr F0, Dim F1 As Single
Dim F1 As Single
Dim F2 As Single
Dim F3 As Single
Dim En As Byte
Dim Raster As Single      'Raster 9 oder 10 kHz
'Dim Zeile As String * 20
Dim Komm As String * 1
dim K as byte
dim Enc as Byte
dim Enc_old as Byte



Declare Sub Regwrite
Declare Sub Siinit
Declare Sub Sifreq
Declare Sub Tune


Config Portb = input
pORTb = 255   'Pullup                                             'Pullups an B0...C3
Open "comb.2:9600,8,n,1" For Input As #1
'Open "comb.1:9600,8,n,1" For Output As #2


Config Sda = Portb.4
Config Scl = Portb.3
I2cinit


Waitms 10
Siinit
Waitms 100

Readeeprom Raster , 40                                            'Raster aus EEPROM-Adresse 40 lesen
If Raster < 9000 Or Raster > 10000 Then Raster = 9000             'Raster = 9kHz, wenn EEPROM leer

If Pinb.2 = 0 Then                                                'Taster gedrckt?
   If Raster = 9000 Then                                          'Toggle Raster
      Raster = 10000                                               '10 kHz   US
      F = 530000                                                   'Startfrequenz f=530 kHz
   Else
      Raster = 90000                                               '9 kHz    EU
      F = 531000                                                   'Startfrequenz f=531 kHz
   End If
   Writeeeprom F , 30
   Writeeeprom Raster , 40
   Do
      Waitms 50
   Loop Until Pinb.2 = 1                                           'Warte bis Taster losgelassen ist
End If

Readeeprom F, 10
if F<8000  then F = 0
F0=F
Clk = 0
Sifreq

Readeeprom F, 20
if F<8000  then F = 0
F1=F
Clk = 1
Sifreq

Readeeprom F, 30
if F<8000  then F = 531000
F2 = F
Clk = 2
Sifreq

Readeeprom Raster , 40                                     'Raster aus EEPROM-Adresse 40 lesen
If Raster < 9000 Or Raster > 10000 Then Raster = 9000      'Raster = 9kHz, wenn EEPROM leer


do
 if pINB.1=0  then Tune
 get#1,K
 if k>0 then
   Input #1 , F1
   F = F1
   Komm = Chr(K)
   'print #2, Komm
   'print #2, F

   If Komm = "A" Then                                       'Clk0 kHz
     F = F1 * 1000
     Clk = 0
     Sifreq
   End If

   If Komm = "a" Then                                       'CLK0 Hz
     Clk = 0
     Sifreq
   End If

   If Komm = "F" Then                                       'Clk1 kHz
     F = F1 *  1000
     Clk = 1
     Sifreq
   End If

   If Komm = "f" Then                                       'Clk1 Hz
     F = F1
     Clk = 1
     Sifreq
   End If


   If Komm = "B" Then                                       'Clk2 kHz
     F = F1 * 1000
     Clk = 2
     Sifreq
   End If

   If Komm = "b" Then                                       'Clk2 Hz
     Clk = 2
     Sifreq
   End If

   If Komm = "k" Then                                       'CLK0 Hz EEPROM
     writeeeprom F, 10
     Clk = 0
     Sifreq
   End If


   If Komm = "l" Then                                       'Clk1 Hz EEPROM
     writeeeprom F, 20
     Clk = 1
     Sifreq
   End If

   If Komm = "m" Then                                       'Clk2 Hz EEPROM
     writeeeprom F, 30
     Clk = 2
     Sifreq
   End If

  else
    if pINB.1=0  then Tune
    'print #2, "Taste"
    waitms 50
    if pINB.2=0  then
      If Raster = 9000 Then                                 '9 kHz-Raster EU
        F2 = F2 + 9000
        If F2 > 1620000 Then F2 = 531000                    'Grenze bei 1611 kHz --> 531 kHz
      Else
        F2 = F2 + 10000                                      '10 kHz-Raster US
        If F2 > 1710000 Then F2 = 530000                    'Grenze bei 1700 kHz --> 530 kHz
      End If
      Writeeeprom F2 , 30                                   'MW-Frequenz ins EEPROM speichern
      F = F2
      Clk = 2
      Sifreq
      do
        waitms 50
      Loop until pINB.2=1
    end if
    if pINB.1=0  then Tune
  end if
loop


Sub Tune                        'Encoder Auswertung
  if F<8000  then F = 7000000
  F=F0
  Clk = 0
  Sifreq
  do
    Enc = PINB
    Enc = Enc / 2
    Enc = Enc and 3
    if Enc.0 < Enc_old.0  then
       if Enc.1=0 then F0=F0+100
       if Enc.1=1 then F0=F0-100
       'print #2, F0
       F=F0
       Clk = 0
       Sifreq
       'waitms 1
    end if
    if Enc.0 > Enc_old.0  then
       if Enc.1=1 then F0=F0+100
       if Enc.1=0 then F0=F0-100
       'print #2, F0
       F=F0
       Clk = 0
       Sifreq
       'waitms 1
    end if
    Enc_old = Enc
    waitms 1
  loop
end sub


Sub Siinit
  Badr = 183 : Bdat = 128 : Regwrite                        'Xtal 8pF
  En = 15
  Badr = 3 : Bdat = En : Regwrite                           'Clk0 Clk1, Clk2 off
  Badr = 15 : Bdat = 0 : Regwrite                           'Xtal = PLL input
  Badr = 16 : Bdat = 15 : Regwrite                          'Clk 0:PLLA, 8mA out
  Badr = 17 : Bdat = 15 : Regwrite                          'Clk 1:PLLA, 8mA out
  Badr = 18 : Bdat = 15 : Regwrite                          'Clk 2:PLLA, 8mA out
  Waitms 10
  Restore Pll900
  Badr = 26
  For N = 26 To 33
    Read Bdat
    Regwrite
  Next N
  Waitms 50
End Sub


Sub Sifreq
Dim P1 As Dword
Dim P11 As Byte At P1 + 0 Overlay
Dim P12 As Byte At P1 + 1 Overlay
Dim P13 As Byte At P1 + 2 Overlay
Dim P2 As Dword
Dim P21 As Byte At P2 + 0 Overlay
Dim P22 As Byte At P2 + 1 Overlay
Dim P23 As Byte At P2 + 2 Overlay
Dim P3 As Dword
Dim P31 As Byte At P3 + 0 Overlay
Dim P32 As Byte At P3 + 1 Overlay
Dim P33 As Byte At P3 + 2 Overlay
Dim A As Dword
Dim B As Dword
Dim C As Dword
Dim D As Dword
Dim E As Dword

Dim G As Single
Dim R As Byte
Dim T As Byte

 If F < 2000 Then
   If F = 0 Then
     En.clk = 1
     Badr = 3 : Bdat = En : Regwrite                        'Ausschalten
   End If
   If F > 0 Then
     En.clk = 0
     Badr = 3 : Bdat = En : Regwrite                        'Einschalten
   End If
 Else
  If F < 8000 Then F = 8000
  If F > 150000000 Then F = 150000000
  G = 900000000 / F                                         'Teiler
  C = 1048575

  R = 0                                                     'R-Teiler R0...2
  While G > 900
    G = G / 2 :                                             'Multisynth-Teiler verkleinern
    R = R + 16
  '  If R = 32 Then                                          'R-Teiler 4 vrmeiden
  '    G = G / 2
  '    R = R + 16
  '  End If
  Wend                                                      'Fout = Fvfo / G / R

  A = G                                                     'G = A + B / C
  G = G - A
  G = G * C                                                 'B = (G - A) * C
  B = G

  D = B * 128
  D = D / C                                                 'D = Int(128 * B / C)

  P1 = 128 * A
  P1 = P1 + D
  P1 = P1 - 512                                             'P1 = 128 * A + (128  * B / C) - 512

  P2 = B * 128
  E = D * C                                                 'E = c  * Int(128 * B / C)
  P2 = P2 - E                                               'P2 = 128 * B - C * Floor ( 128 * B/C)

  P3 = C

  Badr = 8 * Clk
  Badr = Badr + 42
  Bdat = P32
  Regwrite
  Bdat = P31
  Regwrite
  Bdat = P13 + R
  Regwrite
  Bdat = P12
  Regwrite
  Bdat = P11
  Regwrite
  Swap P33
  Bdat = P33 + P23
  Regwrite
  Bdat = P22
  Regwrite
  Bdat = P21
  Regwrite

  En.clk = 0
  Badr = 3 : Bdat = En : Regwrite                           'Einschalten
 End If
End Sub


Sub Regwrite
    I2cstart
    I2cwbyte 192                                            'i2c Adresse SI5351A
    Waitus 1
    I2cwbyte Badr
    Waitus 1
    I2cwbyte Bdat
    Waitus 1
    I2cstop
    Waitus 2
    Badr = Badr + 1
End Sub

End

Pll900:                                                     'PLLA 900 MHz
Data 255 , 255 , 0 , 16 , 0 , 240 , 0 , 0